//+------------------------------------------------------------------+
//|                                              Direction_Brush.mq5 |
//|                                               Copyright TheXpert |
//|                                           theforexpert@gmail.com |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"
#property version   "1.00"
//--- display the indicator in the main window
#property indicator_chart_window
//--- indicator settings
#property indicator_buffers 2
#property indicator_plots   1
//--- plot 1
#property indicator_type1   DRAW_COLOR_LINE
#property indicator_color1  clrWhite,clrRed,clrBlue
//+------------------------------------------------------------------+
//| Enumerate indicator drawing styles                               |
//+------------------------------------------------------------------+
enum EDrawType
  {
   DrawLine,
   DrawHistogram
  };
//--- input parameter
input EDrawType DrawType=DrawLine; // Drawing style
//--- indicator buffers
double Values[];
double Color[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void OnInit()
  {
//--- bind indicator buffer
   SetIndexBuffer(0,Values,INDICATOR_DATA);
   SetIndexBuffer(1,Color,INDICATOR_COLOR_INDEX);
//--- set the indicator display style
   PlotIndexSetInteger(0,PLOT_DRAW_TYPE,DrawType==DrawLine ? DRAW_COLOR_LINE : DRAW_COLOR_HISTOGRAM);
//--- prohibit display of plot values in DataWindow
   PlotIndexSetInteger(0,PLOT_SHOW_DATA,false);
//--- indicator short name
   IndicatorSetString(INDICATOR_SHORTNAME,"With brushed directions");
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//--- start variable for calculation of bars
   int start=prev_calculated;
//--- if the bar is generated, recalculate the indicator value on it
   if(start>0)
      start--;
   else
      start=1;
//--- copy data in the indicator buffer
   ArrayCopy(Values,price,start,start);
//--- the loop for calculating the indicator values
   for(int i=start;i<rates_total;i++)
     {
      //--- define line segment color
      Color[i]=0;
      if(Values[i]>Values[i-1])
         Color[i]=2;
      if(Values[i]<Values[i-1])
         Color[i]=1;
     }
//--- return value of prev_calculated for next call
   return rates_total;
  }
//+------------------------------------------------------------------+
